# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2021.02.19
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class PolicyGroupSpec(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'rule_ids': 'list[str]'
    }

    attribute_map = {
        'name': 'name',
        'rule_ids': 'rule_ids'
    }

    def __init__(self, name=None, rule_ids=None, local_vars_configuration=None):  # noqa: E501
        """PolicyGroupSpec - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._rule_ids = None
        self.discriminator = None

        if name is not None:
            self.name = name
        self.rule_ids = rule_ids

    @property
    def name(self):
        """Gets the name of this PolicyGroupSpec.  # noqa: E501

        The name of the group  # noqa: E501

        :return: The name of this PolicyGroupSpec.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PolicyGroupSpec.

        The name of the group  # noqa: E501

        :param name: The name of this PolicyGroupSpec.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 100):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `100`")  # noqa: E501

        self._name = name

    @property
    def rule_ids(self):
        """Gets the rule_ids of this PolicyGroupSpec.  # noqa: E501

        A list of PolicyRule ids that make up the policy group. The rules are evaluated based on the priority of their action. The ordering is as follows allow_login, deny_login, dont_mfa, do_mfa The first rule that matches will take that rules action.   # noqa: E501

        :return: The rule_ids of this PolicyGroupSpec.  # noqa: E501
        :rtype: list[str]
        """
        return self._rule_ids

    @rule_ids.setter
    def rule_ids(self, rule_ids):
        """Sets the rule_ids of this PolicyGroupSpec.

        A list of PolicyRule ids that make up the policy group. The rules are evaluated based on the priority of their action. The ordering is as follows allow_login, deny_login, dont_mfa, do_mfa The first rule that matches will take that rules action.   # noqa: E501

        :param rule_ids: The rule_ids of this PolicyGroupSpec.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and rule_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `rule_ids`, must not be `None`")  # noqa: E501

        self._rule_ids = rule_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PolicyGroupSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PolicyGroupSpec):
            return True

        return self.to_dict() != other.to_dict()
